head	1.8;
access;
symbols;
locks
	bilbo:1.8; strict;
comment	@ * @;


1.8
date	2004.01.29.01.03.57;	author bilbo;	state Exp;
branches;
next	1.7;

1.7
date	2004.01.29.00.51.48;	author bilbo;	state Exp;
branches;
next	1.6;

1.6
date	2004.01.14.22.17.01;	author bilbo;	state Exp;
branches;
next	1.5;

1.5
date	2004.01.14.22.16.49;	author bilbo;	state Exp;
branches;
next	1.4;

1.4
date	2004.01.06.02.17.30;	author bilbo;	state Exp;
branches;
next	1.3;

1.3
date	2004.01.06.02.14.47;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2004.01.04.22.51.59;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2003.12.23.19.43.36;	author bilbo;	state Exp;
branches;
next	;


desc
@@


1.8
log
@*** empty log message ***
@
text
@#include "config.h"
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <pthread.h>
#include <syslog.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
#include <netdb.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include "util.h"
#include "cfg_file.h"
#include "net.h"
#include "buffer.h"
#include "compat.h"

#define ipv4(x) ((x)>>24)&0xff,((x)>>16)&0xff,((x)>>8)&0xff,(x)&0xff //IP adresa jako 4 slozky

/** zkoukne commandline parametry a pak podle nich nahraje konfiguracni soubor */
void init_config(int argc,char **argv) {
 int i;
 struct sigaction act;
 for(i=1;i<argc;i++) {
  if (eq(argv[i],"-v")) {
   printf (PROGRAM_NAME " " PROGRAM_VERSION "\nCompiled: " __DATE__ " " __TIME__ "\n");
   exit(0);
  }
  if (eq(argv[i],"-c") && (i<argc-1)) {
   configfile=argv[i+1];
   i++;
  } else fatalf("Invalid commandline switch: %s",argv[i])LT_CONFIG_FILE;
 active=load_config(configfile);
 //Ted to nastavi signal handler
 act.sa_handler=sighup_handler;
 sigemptyset(&act.sa_mask);
 act.sa_flags=0;
 chkerror("initconfig:sigaction()",sigaction(SIGHUP,&act,NULL));
}

char valid_char[256];//platne znaky v emailu

/** inicializuje tabulku valid_char */
void make_vch_table() {
 int i;
 static char *vchars="._-";
 for (i=0;i<=255;i++) valid_char[i]=0;
 for (i='A';i<='Z';i++) valid_char[i]=1;
 for (i='a';i<='z';i++) valid_char[i]=1;
 for (i='0';i<='9';i++) valid_char[i]=1;
 for (i=0;i<strlen(vchars);i++) valid_char[(int)(vchars[i])]=1;
}

/** Escape na tecky v smtp komunikaci
 cnt==-1: z .. na jednom radku udela . 
 cnt==+1: z . na jednom radku udela .. */
void message_dots(charbuffer *b,int cnt) {
 int i,len;
 int shift=0;
 char *buf=b->buf;
 len=b->size;
 if (cnt==-1) { //odstran
  if (len<4) return;//"\n..\n" alespon tam byt musi
  for (i=0;i<len-3;i++) {
   if (newline(buf[0]) && buf[1]=='.' && buf[2]=='.' && newline(buf[3])) {
    debug_printf("dvojtecka!\n");
    shift++; //dalsi dvojtecka
   }
   buf[3-shift]=buf[3];//kopiruje znaky vzad
   buf++;
  }
  b->size-=shift;
 } else {
  if (len<3) return;//"\n.\n" alespon tam byt musi
  for (i=0;i<b->size-2;i++) {
   if (newline(buf[0]) && buf[1]=='.' && newline(buf[3])) {
    debug_printf("jednotecka!\n");
    buf_realloc(b,b->size+1);
    shift++; //jen jedna tecka
    memmove(buf+2,buf+1,b->size-i-1);//posun zpravu, dvojujic tak tecku (aby to klient nebral jako konec zpravy)
    b->size++;
   }
   buf++;
  }
 }
}

/** vraci true, pokud podretezec retezce string delky strlen je email fe formatu user@@domena */
int is_canonical_email(const char *string,int s_len) {
 int i,z;
 z=0;
 for(i=0;i<s_len;i++) {
  if (string[i]=='@@') z++;
  else if (!valid_char[(int)(string[i])]) {
   if (!(z==0 && string[i]=='+')) {//nektere znaky jsou platne jen v username
    z=-1;
    break;
   }
  }
 }
 return z==1;
}

/** rozparsuje email z formatu typu "neco" <user@@domena>
a podobnych na normalizovany tvar user@@domena */
char *parse_email(const char *email) {
 char *tmp,*out;
 int l2;
 int l=strlen(email);
 while(l && is_space(email[l-1])) l--;
 //je to primo format user@@domena ?
 if (is_canonical_email(email,l)) return strdup(email);//ANO!
 //Format "neco" <user@@domena>
 //eventuelne =?charset?q?neco= <user@@domena>
 //eventuelne jeste horsi haraburdi <user@@domena>
 if (email[l-1]=='>') {
  tmp=strrchr(email,'<');
  if (tmp) { //uzavreno ve spicatych zavorkach
   tmp++;
   l2=l-(tmp-email)-1;
   if (is_canonical_email(tmp,l2)) {//a je tam email
    out=malloc(l2+1);
    memcpy(out,tmp,l2);
    out[l2]=0;
    return out;
   }
  }
 }
 //Format user@@domena (neco)
 if (email[l-1]==')') {
  tmp=strrchr(email,'(');
  if (tmp) { //ano, je to ono
   l2=(tmp-email)-1;
   if (is_canonical_email(email,l2)) {//a je tam email
    out=malloc(l2+1);
    memcpy(out,email,l2);
    out[l2]=0;
    return out;
   }   
  }
 }
 return strdup(email);//buhvi co to je, vratim v puvodni podobe
}

typedef int (threadfunc)(int param,config *cfg);//funkce threadu

typedef struct { //zaznam pro jeden thread
 threadfunc *func;	//funkce pro thread
 int sock;		//socket pro thread
} thread_rec;

/** wrapper kolem funkce socketu. Funkce (vnitrni) po sobe socket nezvira, to dela tato funkce */
void net_thread(thread_rec *t) {
 int return_socket;
 config *curr;
 curr=lock_config(NULL); 
 debug_printf("config : %x\n",(int)curr);
 return_socket=t->func(t->sock,curr);
 debug_printf("return_socket : %d\n",return_socket);
 if (return_socket!=-1) close(return_socket);
 unlock_config(curr);
 close(t->sock);
 free(t);
 return;
}

/** spusti sitovy thread s danou funkcin a socketem */
void net_thread_run(thread_rec t) {
 thread_rec *dup_t;
 pthread_t thread;
 dup_t=malloc1(sizeof(thread_rec));
 memcpy(dup_t,&t,sizeof(thread_rec));
 //Nastartuje net_thread(dup_t); v novem threadu
 pthread_create(&thread,NULL,(void*)&net_thread,(void*)dup_t);
}

pthread_mutex_t whitelist_lock;//lock na zmenu whitelistu

/** inicializuje logovani hlasek */
void log_init() {
 openlog("sp_proxy",LOG_CONS,LOG_DAEMON);
}

/** zaloguje hlasky. Typicky do syslogu, ale pri debugovani i na STDOUT */
void log_message(int priority,const char *err) {
 syslog(priority,"%s",err);
 debug_printf("[SYSLOG/%d]%s\n",priority,err);
}

/** jako log_message(), ale s formatovanym retezcem jako u printf */
void log_messagef(int priority, const char *fmt,...){
 va_list argptr;
 char s[512];
 va_start(argptr,fmt);	
 _vsnprintf(s,sizeof(s),fmt,argptr);
 va_end(argptr);
 log_message(priority,s);
}

/** posle do logu chybovou hlasku podle kodu v ERRNO */
void log_error() {
 log_message(LOG_ERR,strerror(errno));
}

/** zapise adresu do whitelistu */
void add_to_whitelist(config *cfg,const char *line) {
 int w;//whitelist file
 char b=0;
 if (empty(cfg->whitelistfile)) {
  debug_printf("No whitelist to add to\n");
  return;//neni kam pridavat
 }
 pthread_mutex_lock(&whitelist_lock);
 if (!tree_search(cfg->whitelist,line)) { //este tam neni
  tree_add(&cfg->whitelist,line,(void *)1);//je jedno co se tam vlozi jako value
  w=open(cfg->whitelistfile,O_CREAT | O_RDWR);
  if (w!=-1) {//soubor jsme otevreli
   lseek(w,-1,SEEK_END);
   read(w,&b,1);
   if (b!='\n') {//soubor nekonci na newline
    b='\n';
    write(w,&b,1);//zapiseme newline
   }
   write(w,line,strlen(line));//zapiseme adresu
   write(w,&b,1);//zapiseme newline
   close(w);
  } else { //zaloguj chybu
   log_error();
  }
 }
 pthread_mutex_unlock(&whitelist_lock);
}

/** otestuje jestli vstup input zacina na cmd a vrati
 odkaz na prvni nemezerovy znak za prikazem cmd, nebo NULL, pokud to neni spravny prikaz */
const char *get_cmd_param(const char *cmd,const char *input) {
 if (!str_beginwithi(cmd,input)) return NULL;//neni to prikaz cmd
 input+=strlen(cmd);
 while (is_space(input[0])) input++;
 return input;
}

/** ZKONTROLUJE jestli radka neobsahuje ^RCPT TO:(.*)$
a pokud ano, prida \1 do whitelistu */
void line_checkwhitelist(config *cfg,char *line) {
 const char *param;
 param=get_cmd_param("rcpt to:",line);
 if (param) add_to_whitelist(cfg,param);
}

/**
SMTP proxy - start double pipe, pass input/output unchanged, if input is
^RCPT TO:(.*)$
then add $1 to whitelist (maybe: only if 250 response code received)
if input is DATA, then wait for .
*/
//	    "RCPT TO:$email <CRLF>
int smtp_handler(int s,config *cfg) {
 int ss=-1,client_eof=0,server_eof=0;
 char buf[1024];//buffer na data
 char *line;//nactena radka
 int rb;//nactene bajty v bufferu
 int rc;
 fd_set fds;
 charbuffer b;
 debug_printf("starting smtp handler");
 buf_init(&b,512);
 ss=connect_string(cfg->remotesmtp,DEFAULT_SMTP_PORT);
 if (ss==-1) {
  debug_printf("SMTP: Connection to %s refused\n",cfg->remotesmtp);
  send_line(s,"421 Connection refused");
  return -1;
 }
 FD_ZERO(&fds);
 FD_SET(s,&fds);
 FD_SET(ss,&fds);
 while ((rc=select(max(s,ss)+1,&fds,NULL,NULL,NULL))) {
  if (rc==-1 && errno==EINTR) continue; //zas ten pitomej signal
  if (FD_ISSET(s,&fds)) {
   rb=recv(s,buf,sizeof(buf),MSG_NOSIGNAL);//nacteme
   if (rb==0 || rb==-1) { //EOF nebo chyba spojeni od klienta
    debug_printf("client EOF\n");
    client_eof=1;
    shutdown(ss,1);//uz na server nelze nic posilat
   } else send_all(ss,buf,rb,MSG_NOSIGNAL);//posleme
   //a ted se jukneme do bufferu jestli tam neni nejaky email, co chceme dat do whitelistu
   buf_add(&b,buf,rb);
   while ((line=buf_getline(&b))) {
    line_checkwhitelist(cfg,line);
    free(line);
   }
   debug_printf("data from client (%d)\n",rb);
  }
  if (FD_ISSET(ss,&fds)) { //jen preposilame, co rika smtp server nas celkem nezajima
   rb=recv(ss,buf,sizeof(buf),MSG_NOSIGNAL);//nacteme
   if (rb==0 || rb==-1) { //EOF od serveru || chyba spojeni
    debug_printf("server EOF\n");
    server_eof=1;
    shutdown(s,1);//uz na klient nelze nic posilat
   } else send_all(s,buf,rb,MSG_NOSIGNAL);//posleme
   debug_printf("data from server (%d)\n",rb);
  }
  debug_printf("done\n");
  //zase vrati sety do puvodniho stavu
  FD_ZERO(&fds);
  if (!client_eof) FD_SET(s,&fds);
  if (!server_eof) FD_SET(ss,&fds);
  if (server_eof && client_eof) break;//konec spojeni
 }
 debug_printf("bailout - end of connection\n");
 while ((line=buf_getline(&b))) {
  line_checkwhitelist(cfg,line);
  free(line);
 }
 buf_free(&b);
 return ss;
}

/** vraci 1 pokud je email v seznamu list, jinak 0 */
int email_in_list(tree *list,const char *email) {
 char *real_email,*domain;
 int result;
 real_email=parse_email(email);//user@@domena
 domain=strrchr(real_email,'@@');//@@domena
 if (!domain) domain="@@";//Bez domeny (specialni wildcard)
 result=tree_search(list,real_email) || tree_search(list,domain);
 free(real_email);
 return result;
}

typedef enum {
 pt_filter,
 pt_exec,
 pt_subjectmark,
 pt_classify,
} programtype;


/** spusti program a k nemu oboustrannou pipe - vrati handle na zapis do programu (h_in) a handle na cteni programu (h_out)
Vrati tez pid child procesu (aby se dalo cekat pres waitpid, az vypise vsechen vystup) */
void run_pipe(const char *prog, int *h_in,int *h_out,pid_t *pid) {
 int p_in[2],p_out[2];//read/write pipe file handles
 int err_code;
 pid_t p_pid;
 #ifdef NOT_USE_SH
 int i;
 char *prog_prog,*prog_x,*prog_param;
 char **prog_v;
 int prog_par;
 #endif
 chkerror("run_pipe:pipe(in)",pipe(p_in));
 chkerror("run_pipe:pipe(out)",pipe(p_out));
 debug_printf("will fork soon\n");
 p_pid=chkerror("run_pipe:fork()",fork());
 switch(p_pid) {
  case 0: //Child
   debug_printf("child\n");
   close(p_in[1]);//stdin writing end
   close(p_out[0]);//stdout reading end
   close(0);//STDIN
   dup(p_in[0]);
   close(1);//STDOUT
   dup(p_out[1]);
   close(p_in[0]);//presmerovan stdin z roury na realny stdin
   close(p_out[1]);//presmerovan stdout z roury na realny stdout
   //child si ted prehodil rouru na stdin/stdout a udela exec
   //ZDE zustal otevren z roury pouze STDIN a STDOUT
   #ifdef NOT_USE_SH
   //TODO: jinak, spustit bez shellu
   while (is_space(prog[0])) prog++;//mezery na zacatku nas nezajimaj (stejne by tam nemely byt)
   prog_x=prog_prog=strdup(prog);
   prog_par=0;
   while (prog_x[0]) {
    if (prog_x[0]=='"') {
     prog_x++;
     while (prog_x[0] && (prog_x[0]!='"')) prog_x++; //chybi li uvozovka, dojede az na konec
     if (prog_x[0]) prog_x++;//preskoc uvozovku
    } else if (prog_x[0]=='\'') {
     prog_x++;
     while (prog_x[0] && (prog_x[0]!='\'')) prog_x++; //chybi li uvozovka, dojede az na konec
     if (prog_x[0]) prog_x++;//preskoc uvozovku
    } else {
     while (prog_x[0] && !is_space(prog_x[0])) prog_x++;
    }
    while (prog_x[0] && is_space(prog_x[0])) prog_x++; //preskocit mezery
    prog_par++;
   }
   prog_v=malloc((prog_par+1)*sizeof(char*));
   prog_x=prog_prog;
   for (i=0;i<prog_par;i++) {//doplni NULL znaky
    prog_v[i]=prog_x;
    if (prog_x[0]=='\'') {
     prog_v[i]++;
     prog_x++;
     while (prog_x[0] && (prog_x[0]!='\'')) prog_x++; //chybi li uvozovka, dojede az na konec
     if (prog_x[0]) {prog_x[0]=0;prog_x++;}//preskoc uvozovku
    } else if (prog_x[0]=='"') {
     prog_v[i]++;
     prog_x++;
     while (prog_x[0] && (prog_x[0]!='"')) prog_x++; //chybi li uvozovka, dojede az na konec
     if (prog_x[0]) {prog_x[0]=0;prog_x++;}//preskoc uvozovku
    } else {
     while (prog_x[0] && !is_space(prog_x[0])) prog_x++;
    }
    prog_param=prog_x;
    while (prog_x[0] && is_space(prog_x[0])) prog_x++; //preskocit mezery
    prog_param[0]=0;
    debug_printf("p%d:%s\n",i,prog_v[i]);
   }
   prog_v[prog_par]=NULL;
   err_code=execvp(prog_prog,prog_v);  
   free(prog_v);
   free(prog_prog);
   #else
   err_code=execlp("/bin/sh","/bin/sh","-c",prog,NULL);
   #endif
   if (err_code==-1) { //exec selhal
    debug_printf("exec failed\n");
    exit(255);
   }
   //sem se to stejne nedostane
   exit(EXIT_FAILURE);
   return;
  default: //Parent
   debug_printf("parent\n");
   close(p_in[0]);//stdin reading end
   close(p_out[1]);//stdout writing end
   *h_in=p_in[1];
   *h_out=p_out[0];
   //oba konce roury se predaji ven
   *pid=p_pid;
   return;
 }
}

/** zapise obsah msg do h_in, zaroven vyzvedne obsah z h_out do
 bufferu msg_out, a  po ukonceni procesu pid vrati jeho navratovou hodnotu */
int pipe_filter(charbuffer *msg,charbuffer *msg_out,pid_t pid,int h_in,int h_out) {
 fd_set rs,ws;

 int br=0;//bytes read <- h_out
 int bw=0;//bytes written -> h_in
 int b;
 int input_sent=0;
 int status;//navratovy kod child procesu
 //nastavi noblocking na file descriptory
 set_nonblock(h_in);
 set_nonblock(h_out);

 for(;;) {
  FD_ZERO(&rs);
  FD_SET(h_out,&rs);

  if (!input_sent) {
   FD_ZERO(&ws);
   FD_SET(h_in,&ws);
   b=select(max(h_in,h_out)+1,&rs,&ws,NULL,NULL);
  } else {
   b=select(h_out+1,&rs,NULL,NULL,NULL);//vstup jsme poslali
  }
  if (b==-1 && errno==EINTR) continue; //zas ten pitomej signal
  if (b==-1) goto fail;
  if(!input_sent && FD_ISSET(h_in,&ws)) { //write, dokud je co
   if (bw<msg->size) {//je co psat
    b=write(h_in,msg->buf+bw,msg->size-bw);
    if (b==-1) goto fail;
    bw+=b;
   } else { // uz jsme poslali vsechno, tak zavrem vstup
    debug_printf("will close STDIN...");
    close(h_in);
    debug_printf("closed\n");
    input_sent=1;
   }
  }
  if(FD_ISSET(h_out,&rs)) { //read
   buf_realloc(msg_out,msg_out->size+4096);//zvetsit o 4 kb
   b=read(h_out,msg_out->buf+br,msg_out->a_size-br);
   if (b==-1) goto fail;
   br+=b;
   msg_out->size=br;
   if (b==0) break;//prave jsme nacetli end-of-file
  }
 }
 //Data jsem poslal a proces uz mi taky nic dalsiho poslat nechce
 debug_printf("exit-waiting\n");
 //zavru file descriptory
 close(h_in);
 close(h_out);
 //a ted pockame na exit status procesu       
 if (waitpid(pid,&status,0)!=pid) return -1;//proces asi chcipnul jeste nez jsem se dostal sem
 if (WIFEXITED(status)) return WEXITSTATUS(status);//normalne se ukoncil
 return -1;//proces umrel (asi signal)
fail:
 //neco se pokazilo: vratim original
 buf_realloc(msg_out,msg->size);
 memcpy(msg_out->buf,msg->buf,msg->size);
 close(h_in);
 close(h_out);
 return -1;
}

/** spusti program, msg je buffer, ktery obsahuje vstupni zpravu, pokud pt je
 pt_subjectmark, nebo pt_filter, bude nahrazena vystupni zpravou */
int run_prog(charbuffer *msg,const char *prog,programtype pt) {
 int h_in,h_out;//handle na psani/cteni programu
 pid_t pid;//pid programu
 char *buf;
 int offset;
 charbuffer result;//buffer na vysledek filtrace
 int res_code;
 if (pt==pt_subjectmark) {
  int l;
  debug_printf("-- Mark subject: %s\n",prog);
  buf=msg->buf;
  for(;;) {
   if (str_beginwithi("subject:",buf)) {
    buf+=8;//preskocit "subject:"
    debug_printf("MARK\n");
    while (is_space(buf[0])) buf++;//pereskocit mezery an zacatku
    //Mno a mam misto kam to vlozit
    l=strlen(prog);
    if (msg->size+l>msg->a_size) { //maly buffer, realokuji
     buf_realloc(msg,msg->size+l);
    }
    offset=buf-msg->buf;  
    memmove(buf+l,buf,msg->size-offset);//odsunout data dale
    memmove(buf,prog,l);//vlozit znacku
    msg->size+=l;
    return 0;
   }
   buf=strchr(buf,'\n');//dalsi radka
   if (!buf) break;//posledni radka
   buf++;
   if (buf>msg->buf+msg->size) break;//konec bufferu
   if (*buf=='\r' || *buf=='\n') break; //akorat prazdna radka - skoncily hlavicky
  }
  debug_printf("NO SUBJ\n");
  //zprava neobsauje Subject: - tak ho vlozim
  l=strlen("Subject: \r\n")+strlen(prog);
  buf_realloc(msg,msg->size+l);
  memmove(buf+l,buf,msg->size);//odsunout data dale
  memcpy(buf,"Subject: ",9);//vlozit celou radku
  memcpy(buf+9,prog,strlen(prog));
  memcpy(buf+l-2,"\r\n",2);//vlozit znacku
  msg->size+=l;
  return 0; 
 }
 //spusti se program
 debug_printf("-- exec something: %s\n",prog);
 run_pipe(prog,&h_in,&h_out,&pid);
 debug_printf("-- pipe setup pid=%d\n",pid);
 buf_init(&result,512);
 res_code=pipe_filter(msg,&result,pid,h_in,h_out);
 debug_printf("-- something finished: ret=%d\n",res_code);
 //close(h_in); pipe_filter si je zavre
 //close(h_out); pipe_filter si je zavre
 if (res_code) { //program vratil chybovy kod
  debug_printf("Error (%d) while executing program '%s'",res_code,prog);
  log_messagef(LOG_WARNING,"Error (%d) while executing program '%s'",res_code,prog);
  buf_free(&result);
  return 0;
 }
 debug_printf("-- check result");
 switch(pt) { //program spusten, co ted s vysledkem?
  case pt_filter://filtrace emailu
   if (result.size) {
    buf_free(msg);//originalni zlikviduji
    *msg=result;//a nahradim vysledkem
    return 0;
   } else return 0;//nic nevratil
  case pt_exec: //spusteni programu
   buf_free(&result);//co vyplivl na stdout nas nezajima, originalni zpravu nechame
   return 0;
  case pt_classify: //chceme klasifikaci - vratime hodnotu, original zpravu nechame
   buf=buf_firstline(&result);
   if (!buf) {//nic nevratil! Nebo nevratil celou radku ukoncenou newlinem
    debug_printf("%d bytes\n",result.size);
    log_messagef(LOG_WARNING,"Classificator '%s' have not returned any value!",prog);
    return 0;
   }
   offset=atoi(buf);//prevedeme na cislo
   free(buf);
   buf_free(&result);//co vyplivl na stdout nas nezajima
   debug_printf("\n >>>>> CLASSIFIED: %d <<<<<<\n\n",offset);
   return offset;//vratime hodnotu klasifikace
  default:;//sem to stejne nedojde
 }
 return 0;
}

/** spusti vsechny programy postupne v jejich poradi ze seznamu list
 na zpravu msg, programy dostanou parametry state a pt */
void run_programlist(charbuffer *msg,priority_list *filt,int state,programtype pt) {
 while(filt) {
  if (state==-1 || (state>=filt->min && state<=filt->max)) { //spravna hodnota
   run_prog(msg,filt->prog,pt);
  }
  filt=filt->next;
 }
}

/** spusti na zpravy b_message prefilter, vrati prefiltrovanou zpravu */
charbuffer run_prefilter(charbuffer *b_message,priority_list *filt) {
 charbuffer out;
 out.a_size=out.size=b_message->size;
 out.buf=malloc(out.size);
 memcpy(out.buf,b_message->buf,out.size);
 run_programlist(&out,filt,-1,pt_filter);
 return out;
}
 
/** na zpravu spusti programy postfilter dle nastaveni */
void run_postfilter(charbuffer *b_message,priority_list *filt,int state) {
 run_programlist(b_message,filt,state,pt_filter);
}

/** na zpravu spusti programy postaction dle nastaveni */
void run_postaction(charbuffer *b_message,priority_list *filt,int state) {
 run_programlist(b_message,filt,state,pt_exec);
}

/** na zpravu spusti znackovac Subjectu dle nastaveni */
void run_subjmark(charbuffer *b_message,priority_list *filt,int state) {
 run_programlist(b_message,filt,state,pt_subjectmark);
}

/** na zpravu spusti klasifikator dle nastaveni a vrati hodnotu zpravy */
int run_classificator(charbuffer *b_message,const char *prog) {
 return run_prog(b_message,prog,pt_classify);
}

/** POP3 socket handler */
int pop3_handler(int s,config *cfg) {
 int ss=-1,client_eof=0,server_eof=0;
 int i;
 int rc;
 int is_blacklisted;
 int is_whitelisted;
 int state;//vnistrni stav
 char buf[1024];//buffer na data
 char *line=0,*line_remote=0;//nactena radka
 char *username;//pop3 username
 char *hostname;//pop3 hostname
 const char *param;
 int rb;//nactene bajty v bufferu
 fd_set fds;
 charbuffer b,b_remote,b_message;
 debug_printf("starting pop3 handler");
 buf_init(&b,512);
 buf_init(&b_remote,512);

 send_line(s,"OK sp_proxy pop3 ready");
 nextcommand:
 while ((line=socket_getline(&b,s))) {
  debug_printf("CMD: %s\n",line);
  param=get_cmd_param("quit",line);
  if (param) {//user@@host expected
   send_line(s,"+OK bye");
   buf_free(&b);
   buf_free(&b_remote);
   free(line);
   return ss;
  }  
  param=get_cmd_param("user",line);
  if (param) {//user@@host expected
   hostname=strrchr(param,'@@');
   if (!hostname) {
    send_line(s,"-ERR Send USER in realuser@@pop3host format!");
   } else {
    username=strdup(param);
    i=(hostname-param);
    username[i]=0;//"prerizneme" parametr na user a host cast.
    hostname=username+i+1;
    debug_printf("Connecting to %s / %s\n",username,hostname);
    ss=connect_string(hostname,DEFAULT_POP3_PORT);
    if (ss==-1) {
     debug_printf("Connection refused\n");
     send_line(s,"-ERR Connection refused");
     free(line);
     continue;//nacist dalsi prikaz
    }
    line_remote=socket_getline(&b_remote,ss);//nacte greeting message od serveru
    if (str_beginwithi("+OK",line_remote)) { //greeting message je +OK
     send_linef(ss,"USER %s",username);
     free(line_remote);
     line_remote=socket_getline(&b_remote,ss);
     if (str_beginwithi("+OK",line_remote)) { //na user je +OK
      send_line(s,line_remote);//posle odpoved serveru klientovi
      free(line_remote);
      free(line);
      break;//dalsi faze: pripojen na server
     } else {
      send_line(s,line_remote);//posle odpoved serveru klientovi
      free(line_remote);
      free(line);
      continue;//nacist dalsi prikaz
     }
    } else { //pop3 server po pripojeni rek neco jineho nez +OK
     debug_printf("bad response: %s\n",line_remote);
     send_line(s,line_remote);//posleme dal
     free(line_remote);
     free(line);
     continue;//nacist dalsi prikaz
    }
   }
  } else {
   send_line(s,"-ERR Send USER command first!");
  }
  free(line);
 }

 if (!line) { //zavrel pripojeni
  buf_free(&b);
  buf_free(&b_remote);
  return ss;
 }

 debug_printf("Connected to %s / %s\n",username,hostname);
 free(username);//uz ho nepotrebujem
 //TED jsme pripojeni na server, poslali jsme username

 FD_ZERO(&fds);
 FD_SET(s,&fds);
 FD_SET(ss,&fds);
 while ((rc=select(max(s,ss)+1,&fds,NULL,NULL,NULL))) {
  if (rc==-1 && errno==EINTR) continue; //zas ten pitomej signal
  if (FD_ISSET(s,&fds)) {
   rb=recv(s,buf,sizeof(buf),MSG_NOSIGNAL);//nacteme
   if (rb==0 || rb==-1) { //EOF od klienta || chyba spojeni
    debug_printf("client EOF\n");
    client_eof=1;
    shutdown(ss,1);//uz na server nelze nic posilat
   } else {
    buf_add(&b,buf,rb);
    while ((line=buf_getline(&b))) {
     param=get_cmd_param("pass",line);
     if (param) {
      send_line(ss,line);
      free(line);
      line_remote=socket_getline(&b_remote,ss);//nacte odpoved
      send_line(s,line_remote);//odpoved serveru poslu klientovi
      if (!str_beginwithi("+OK",line_remote)) { //na user NENI +OK
       debug_printf("PASS failed!\n");//blby heslo
       free(line_remote);
       send_line(ss,"QUIT");
       shutdown(ss,1);//zavreme spojeni
       close(ss);//odpoved necht si shnije v /dev/null
       ss=-1;
       goto nextcommand;//zpet na zacatek protokolu: ocekavam USER
      }
      free(line_remote);//je to ok, heslo proslo
      continue;//dalsi radka od klienta
     }
     param=get_cmd_param("retr",line);
     if (param) {
      debug_printf("client send RETR %s\n",param);
      send_line(ss,line);//posleme na server
      free(line);
      line_remote=socket_getline(&b_remote,ss);//nacte odpoved
      send_line(s,line_remote);//odpoved serveru poslu klientovi
      debug_printf("- we have response\n");
      if (!str_beginwithi("+OK",line_remote)) { //na retr NENI +OK
       debug_printf("RETR failed!\n");
       free(line_remote);
      } else { //Prijmu zpravu a zpracuju ji
       state=0;//headers
       is_whitelisted=0;
       is_blacklisted=0;
       buf_init(&b_message,4096);
       debug_printf("- we get message\n");
       for(;;) {//nekonecny cyklus
        line_remote=socket_getline(&b_remote,ss);//nacte odpoved
        if (!line_remote) { //spadlo spojeni - koncime
         free(line_remote);
         buf_free(&b);
         buf_free(&b_remote);
         buf_free(&b_message);
         return ss;
        }
        if (eq(line_remote,".")) break;//mam celou message
        buf_addline(&b_message,line_remote);
        if (empty(line_remote)) state=1;//prazdna radka - zacina telo zpravy
        if (state==0) { // prijimam hlavicky
         param=get_cmd_param("from:",line_remote);
         if (param) {
          //TODO: hlavicka muze byt obcas pres vic radek
          if (email_in_list(cfg->whitelist,param)) is_whitelisted=1;
          if (email_in_list(cfg->blacklist,param)) is_blacklisted=1;
         }
        }
        free(line_remote);
       }
       free(line_remote);
       debug_printf("- we have message\n");
       message_dots(&b_message,-1); // vytipat tecky pripadne
       //v b_message je cela zprava
       if (is_whitelisted) state=cfg->whitelist_level;
       else if (is_blacklisted) state=cfg->blacklist_level;
       else { //prozene se to classification (+) a classify-filter
        charbuffer b2;
        debug_printf("- we classify\n");

        b2=run_prefilter(&b_message,cfg->p_prefilt);
        state=run_classificator(&b2,cfg->p_class);
        buf_free(&b2);
       }
       debug_printf("- we run filters (level=%d)\n",state);
       run_postfilter(&b_message,cfg->p_postfilt,state);
       run_postaction(&b_message,cfg->p_postact,state);
       run_subjmark(&b_message,cfg->subject_mark,state);
       message_dots(&b_message,+1); // zdvojit tecky pripadne
       debug_printf("- we send result\n");
       //Mno a ted uz tu zpravu jen poslu
       i=send_all(s,b_message.buf,b_message.size,MSG_NOSIGNAL);
       buf_free(&b_message);
       if (i==-1) { //vypadnout ven, spadlo spojeni
        debug_printf("connection problem\n");
        goto fatal_error;
       }
       send_line(s,".");//a na konci nesmime zapomenout poslat tecku
       debug_printf("- all sent\n");
      }
      continue;
     }
     //zbyle prikazy se jan tak poslou a pak se preposle zpet odpoved (pri dalsim pruchodu selectem)
     send_line(ss,line);
     free(line);
    }
   }
//   debug_printf("data from client (%d)\n",rb);
  }
  if (FD_ISSET(ss,&fds)) {
   //jen preposilame data z pop3 serveru
   //v teto casti preposilame reakci na nejaky neznamy prikaz
   rb=recv(ss,buf,sizeof(buf),MSG_NOSIGNAL);//nacteme
   if (rb==0 || rb==-1) { //EOF od serveru || chyba spojeni
    debug_printf("server EOF\n");
    server_eof=1;
    shutdown(s,1);//uz na klient nelze nic posilat
   } else send_all(s,buf,rb,MSG_NOSIGNAL);//posleme
//   debug_printf("data from server (%d)\n",rb);
  }
//  debug_printf("done\n");
  //zase vrati sety do puvodniho stavu
  FD_ZERO(&fds);
  if (!client_eof) FD_SET(s,&fds);
  if (!server_eof) FD_SET(ss,&fds);
  if (server_eof && client_eof) break;//konec spojeni
 }
fatal_error:
 debug_printf("bailout - end of connection\n");
 buf_free(&b);
 buf_free(&b_remote);
 return ss;
}

int pop3s;//socket na POP3
int smtps;//socket na SMTP

/** zmeni sockety, pokud je po zmene konfigurace nuntno naslouchat na jinych portech */
void main_rebind(int change_smtp,int change_pop3) {
 if (change_smtp) {
  close(smtps);
  smtps=net_listen(active->smtp_port);
 }
 if (change_pop3) {
  close(pop3s);
  pop3s=net_listen(active->pop3_port);
 }
}

/** main - hlavni funkce programu */
int main(int argc,char **argv) {
 int is;
 struct sockaddr_in addr;
 int sof;
 fd_set fds;
 thread_rec tx;

 debug_printf("pop3_proxy\n");

 make_vch_table();
 log_init();
 debug_printf("log_init done\n");
 pthread_mutex_init(&whitelist_lock,NULL);
 config_mutex_lock_init();
 debug_printf("mutex init done\n");
 init_config(argc,argv);
 debug_printf("init_config done\n");

 pop3s=net_listen(active->pop3_port);
 smtps=net_listen(active->smtp_port);
 FD_ZERO(&fds);
 FD_SET(pop3s,&fds);
 FD_SET(smtps,&fds);
 sof=sizeof(addr);
 debug_printf("Awaiting connections: %d %d -> %d\n",smtps,pop3s,max(pop3s,smtps)+1);
 while ((is=select(max(pop3s,smtps)+1,&fds,NULL,NULL,NULL))) {
  if (is==-1 && errno==EINTR) {//signal - nezajima
   debug_printf("signal - ignoring!");
  } else {
   debug_printf("Wake: connection\n");
   if (FD_ISSET(pop3s,&fds)) {
    is=accept(pop3s,(struct sockaddr *)(&addr),&sof);
    tx.func=pop3_handler;
    tx.sock=is;
    debug_printf("pop3\n");
    net_thread_run(tx);
   }
   if (FD_ISSET(smtps,&fds)) {
    is=accept(smtps,(struct sockaddr *)(&addr),&sof);
    tx.func=smtp_handler;
    tx.sock=is;
    debug_printf("smtp\n");
    net_thread_run(tx);
   }
  }
  //zase vrati sety do puvodniho stavu
  FD_ZERO(&fds);
  FD_SET(pop3s,&fds);
  FD_SET(smtps,&fds);
  debug_printf("done\n");
 }
 //sem by se to nemelo dostat
 return EXIT_FAILURE;
}
@


1.7
log
@*** empty log message ***
@
text
@d26 1
a26 1
#define ipv4(x) ((x)>((x)>>8)&0xff,(x)&0xff //IP adresa jako 4 slozky
d28 1
a28 3
//parametry: sp_proxy [-c alt.config.filename]

/** nahraje konfiguracni soubor a pak ho (eventuelne) upravi podle commandline parametru */
d33 4
@


1.6
log
@*** empty log message ***
@
text
@d4 3
a8 1
#include <sys/wait.h>
a18 2
#include <pthread.h>
#include <syslog.h>
a25 3

//TODO: pridelat timeouty

d40 2
a41 1
 if (!configfile) configfile=DEFAULT_CO;
d62 34
d288 2
a289 2
   rb=recv(s,buf,sizeof(buf),0);//nacteme
   if (rb==0) { //EOF od klienta
d293 1
a293 1
   } else send(ss,buf,rb,0);//posleme
d303 2
a304 2
   rb=recv(ss,buf,sizeof(buf),0);//nacteme
   if (rb==0) { //EOF od serveru
d308 1
a308 1
   } else send(s,buf,rb,0);//posleme
d333 1
d353 6
d375 48
d424 1
d438 1
a446 1
 int ifl,ofl;
d455 2
a456 4
 chkerror("pipe_filter:fcntl()",ifl=fcntl(h_in,F_GETFL));
 chkerror("pipe_filter:fcntl()",ofl=fcntl(h_out,F_GETFL));
 chkerror("pipe_filter:fcntl()",fcntl(h_in,F_SETFL,ifl|O_NONBLOCK));
 chkerror("pipe_filter:fcntl()",fcntl(h_out,F_SETFL,ofl|O_NONBLOCK));
d477 1
d479 1
d485 1
a485 1
   b=read(h_out,msg_out+br,msg_out->a_size-br);
d492 5
d523 31
a553 11
  if (str_beginwithi("subject:",buf)) {
   while (is_space(buf[0])) buf++;//pereskocit mezery an zacatku
   //Mno a mam misto kam to vlozit
   l=strlen(prog);
   if (msg->size+l>msg->a_size) { //maly buffer, realokuji
    buf_realloc(msg,msg->size+l);
   }
   offset=buf-msg->buf;  
   memmove(buf+l,buf,msg->size-offset);//odsunout data dale
   memmove(buf,prog,l);//vlozit znacku
  }
d566 2
a567 1
  log_messagef(LOG_WARNING,"Error (%d) while executing program '%s'",result,prog);
d571 1
d583 1
a583 1
   buf=buf_getline(&result);
d585 1
d592 1
d663 1
a663 1
  printf("CMD: %s\n",line);
d682 1
a682 1
    printf("Connecting to %s / %s\n",username,hostname);
d685 1
a685 1
     printf("Connection refused\n");
d707 1
a707 1
     printf("bad response: %s\n",line_remote);
d726 1
a726 1
 printf("Connected to %s / %s\n",username,hostname);
d736 3
a738 3
   rb=recv(s,buf,sizeof(buf),0);//nacteme
   if (rb==0) { //EOF od klienta
    printf("client EOF\n");
d751 1
a751 1
       printf("PASS failed!\n");//blby heslo
d771 1
a771 1
       printf("RETR failed!\n");
d794 1
a794 1
//TODO: hlavicka muze byt obcas pres vic radek
d803 1
d815 1
a815 1
       debug_printf("- we run filters\n");
d819 1
d822 1
a822 1
       send(s,b_message.buf,b_message.size,0);
d824 6
d838 1
a838 1
   printf("data from client (%d)\n",rb);
d843 3
a845 3
   rb=recv(ss,buf,sizeof(buf),0);//nacteme
   if (rb==0) { //EOF od serveru
    printf("server EOF\n");
d848 2
a849 2
   } else send(s,buf,rb,0);//posleme
   printf("data from server (%d)\n",rb);
d851 1
a851 1
  printf("done\n");
d858 2
a859 1
 printf("bailout - end of connection\n");
d865 15
a881 2
 int pop3s;//socket na POP3
 int smtps;//socket na SMTP
d888 2
d892 1
d895 1
d897 1
@


1.5
log
@*** empty log message ***
@
text
@d27 3
a29 1
//TODO: pridelat tim)>>24)&0xff,((x)>>16)&0xff,((x)>>8)&0xff,(x)&0xff //IP adresa jako 4 slozky
@


1.4
log
@*** empty log message ***
@
text
@d1 1
d6 1
d22 2
a23 1
#include "config.h"
d29 1
a29 1
#define ipv4(x) ((x)>>24)&0xff,((x)>>16)&0xff,((x)>>)&0xff,(x)&0xff //IP adresa jako 4 slozky
a32 52
int chkerror(char *action,int retcode) {
 if (retcode!=-1) return retcode;
 perror(action);
 exit(EXIT_FAILURE);
 return -1;
}

//vraci true, je li znak v bufferu
int have_char(char c,char *buf,int len) {
 int i;
 for (i=0;i<len;i++) {
  if (buf[i]==c) return 1;
 }
 return 0;
}

/** posle retezec + CRLF na socket */
void send_line(int s,char *str) {
 char buf[2048];//buffer
 snprintf(buf,sizeof(buf),"%s\r\n",str);
 buf[sizeof(buf)-1]=0;
 send(s,buf,strlen(buf),0);
}

/** jako send_line(), ale s formatovanym retezcem jako u printf */
void send_linef(int sock,char *fmt,...){
 va_list argptr;
 char s[512];
 va_start(argptr,fmt);	
 _vsnprintf(s,sizeof(s),fmt,argptr);
 va_end(argptr);
 send_line(sock,s);
}

/** zacne naslouchat na portu [port], vrati socket */
int net_listen(int port) {
 int s;//socket
// int noblock=1;
 struct sockaddr_in addr;

 addr.sin_port=htons(port);
 addr.sin_addr.s_addr=htonl(INADDR_ANY);

 s=socket(PF_INET,SOCK_STREAM,IPPROTO_TCP);
 chkerror("socket()",s);
 chkerror("bind()",bind(s,(struct sockaddr *)(&addr),sizeof(addr)));
 chkerror("listen()",listen(s,5));
// setsockopt(s,SOL_SOCKET,SO_NONBLOCK,&noblock, sizeof(int));
 fcntl(s,F_SETFL,O_NONBLOCK);
 return s;
}

d49 1
a49 1
 sigaction(SIGHUP,&act,NULL);
d125 2
a126 2
 threadfunc *func;
 int sock;
d134 1
a134 1
 debug_printf("config : %x\n",curr);
a153 134
/** prevede port na cislo */
int port_from_string(const char *port) {
 struct servent *s;
 s=getservbyname(port,"tcp");
 if (s) {
  debug_printf("found port -> %s = %d\n",port,ntohs(s->s_port));
  return ntohs(s->s_port);
 }
 return atoi(port);
}

/** pro dany host vrati jeho IPV4 adresu */
long resolve(const char *name) {
 struct hostent *ph;
 if (!name || !*name) return INADDR_NONE;
// if (isaddrp(name)) return ntohl(inet_addr(name));
 ph=gethostbyname2(name,AF_INET);
 if (!ph) return INADDR_NONE;
 if (ph->h_length!=4 || ph->h_addrtype!=AF_INET) return INADDR_NONE;
 return ntohl(*((long *)(ph->h_addr)));
}


/** otevre konexi na dany host a port, vrati socket nebo -1 pokud chyba */
int open_connection(const char *host,int port) {
 struct sockaddr_in inx;
 int sock;
 long ip;
 int i;

 debug_printf ("open connection: %s:%d\n",host,port);

 sock=socket(AF_INET,SOCK_STREAM,IPPROTO_IP);
 memset(&inx,0,sizeof(inx));
 if (sock==-1) return -1;
 ip=resolve(host);
 if (ip==INADDR_NONE) return -1;
 debug_printf("Connecting to %ld.%ld.%ld.%ld\n",ipv4(ip));
 inx.sin_family=AF_INET;
 inx.sin_port=htons(port);
 inx.sin_addr.s_addr=htonl(ip);
 i=connect(sock,(struct sockaddr*)&inx,sizeof(inx));
 if (i==-1) {
  close(sock);
  return -1;
 }
 return sock;
}

/** priconnecti se na adresu ve tvaru (hostname|adresa)(:port)?
 def_port se pouzije, pokud port neni zadan*/
int connect_string(const char *host,int def_port) {
 char *host2;
 char *pos;
 int s;
 host2=strdup(host);
 pos=strrchr(host2,':');
 if (pos) {
  *pos=0;
  pos++;
  def_port=port_from_string(pos);
 }
 s=open_connection(host2,def_port);
 free(host2);
 return s;
}

typedef struct{ //dynamicky buffer na data
 char *buf;//buffer na data
 int size;//bajtu v bufferu
 int a_size;//alokovana velikost
} charbuffer;

/** inicializuje promennou na defaultni hodnoty + naalokuje pocatecni buffer */
void buf_init(charbuffer *b,int size) {
 b->buf=malloc1(size);
 b->size=0;
 b->a_size=size;
}


/** realokuje buffer na velikost alespon minsize bajtu. Pokud je buffer uz dostatecne velky, nedela nic */
void buf_realloc(charbuffer *b,int minsize) {
 char *nb;
 if (minsize>b->a_size) {
  b->a_size=(minsize+511) & 0xfffff700;//realokuje na nejblizsi vyssi nasobek 512 bajtu
  #ifdef DEBUG
  if (minsize>b->a_size) fatalf("buf_add: sem se splet .... %d,%d",minsize,b->a_size);
  #endif
  nb=realloc(b->buf,b->a_size);
  if (!nb) fatalf("Failed to reallocate buffer to %d bytes",b->a_size);
  b->buf=nb;
 }
}

/** prida do bufferu data */
void buf_add(charbuffer *b,const char *data,int datalen) {
 if (!datalen) return;
 buf_realloc(b,b->size+datalen);
 memcpy(b->buf+b->size,data,datalen);
 b->size+=datalen;
}

/** uvolni pamet zabranou bufferem */
void buf_free(charbuffer *b) {
 free(b->buf);
}

/** vrati a odstrani radky ukoncenou CRLF z bufferu, nebo NULL pokud tam takova radka neni */
char *buf_getline(charbuffer *b) {
 int i;
 char *u=b->buf;
 char *res;
 if (b->size<2) return NULL;
 for (i=1;i<b->size;i++) {//od 2.bajtu
  if (u[i]=='\n' && u[i-1]=='\r') { //CRLF
   u[i-1]=0;
   res=strdup(u);
   b->size-=(i+1);
   memmove(u,u+i+1,b->size);
   return res;
  }
 }
 return NULL;
}

static const char *crlf="\r\n";//retezec CR+LF

/** prida do buffer radku line + znaky CR a LF */
void buf_addline(charbuffer *b,const char *line) {
 buf_add(b,line,strlen(line));
 buf_add(b,crlf,2);
}

a227 19

/** nacte radku ze socketu, zbyle znaky (za koncem radky)
 vrati do bufferu, pokud je radka jiz v bufferu, nic nenacita.
 Pri uzavreni spojeni vraci NULL*/
char *socket_getline(charbuffer *b, int sock) {
 char buf[1024];//buffer na data
 char *line;//nactena radka
 int rb;//nactene bajty
 line=buf_getline(b);
 if (line) return line;
 while((rb=recv(sock,buf,sizeof(buf),0))) {
  buf_add(b,buf,rb);
  line=buf_getline(b);
  if (line) return line;
 }
 return NULL;
}


d240 1
d243 1
d247 1
a247 1
  debug_printf("SMTP: Connection refused\n");
d254 2
a255 1
 while (select(max(s,ss)+1,&fds,NULL,NULL,NULL)) {
d323 1
d327 1
a331 1
   close(p_in[0]);//presmerovan stdin z roury na realny stdin
d334 1
d336 1
d339 1
d343 1
a343 1
   exit(0);
d346 1
d359 57
a415 3
 
 //TODO: dodelat;
 //TODO: tuhle funkci dopsat, viz pipe_select u berana
d429 1
d445 1
d447 1
d450 3
a452 2
 close(h_in);
 close(h_out);
d504 1
d509 1
d514 1
d519 1
d528 1
d540 1
d617 2
a618 1
 while (select(max(s,ss)+1,&fds,NULL,NULL,NULL)) {
d648 1
d653 1
d662 1
d686 1
d692 2
d698 1
d702 1
d740 1
d763 19
a781 15
 while (select(max(pop3s,smtps)+1,&fds,NULL,NULL,NULL)) {
  debug_printf("Wake: connection\n");
  if (FD_ISSET(pop3s,&fds)) {
   is=accept(pop3s,(struct sockaddr *)(&addr),&sof);
   tx.func=pop3_handler;
   tx.sock=is;
   debug_printf("pop3\n");
   net_thread_run(tx);
  }
  if (FD_ISSET(smtps,&fds)) {
   is=accept(smtps,(struct sockaddr *)(&addr),&sof);
   tx.func=smtp_handler;
   tx.sock=is;
   debug_printf("smtp\n");
   net_thread_run(tx);
d789 1
a789 1
 //select selhal -> nejaka chyba v siti
@


1.3
log
@*** empty log message ***
@
text
@d17 1
d21 2
d85 1
d94 5
d136 1
a136 1
 while(l && email[l-1]==' ') l--;
d183 1
a183 1
 printf("config : %x\n",curr);
d185 1
a185 1
 printf("return_socket : %d\n",return_socket);
d208 1
a208 1
  printf("found port -> %s = %d\n",port,ntohs(s->s_port));
d233 1
a233 1
 printf ("open connection: %s:%d\n",host,port);
d240 1
a240 1
 printf("Connecting to %ld.%ld.%ld.%ld\n",ipv4(ip));
d283 3
a285 2
/** prida do bufferu data */
void buf_add(charbuffer *b,const char *data,int datalen) {
d287 5
a291 4
 if (!datalen) return;
 if (b->size+datalen>b->a_size) {
  b->a_size=(b->a_size+b->size+511) & 0xfffff700;//realokuje na nejblizsi vyssi nasobek 512 bajtu
  if (b->size+datalen>b->a_size) fatalf("buf_add: sem se splet .... %d,%d,%d",b->size,datalen,b->a_size);
d296 6
d345 1
a345 1
void log_message(const char *err, int priority) {
d347 11
a357 1
 printf("[SYSLOG/%d]%s\n",priority,err);
d362 1
a362 1
 log_message(strerror(errno),LOG_ERR);
d370 1
a370 1
  printf("No whitelist to add to\n");
d399 1
a399 1
 while (input[0]==' ' || input[0]=='\t') input++;
a408 5
/* if (str_beginwithi("rcpt to:",line)) {
  line+=8;//strlen("rcpt to:");
  while (line[0]==' ' || line[0]=='\t') line++;
  add_to_whitelist(cfg,line);
 }*/
d447 1
a447 1
  printf("SMTP: Connection refused\n");
d458 1
a458 1
    printf("client EOF\n");
d468 1
a468 1
   printf("data from client (%d)\n",rb);
d473 1
a473 1
    printf("server EOF\n");
d477 1
a477 1
   printf("data from server (%d)\n",rb);
d479 1
a479 1
  printf("done\n");
d486 1
a486 1
 printf("bailout - end of connection\n");
d513 47
d561 54
a614 6
    //TODO: spustit program
 switch(pt) {
  case pt_filter://TODO: filter;
  case pt_exec://TODO: exec;
  case pt_subjectmark: //TODO; mark subject;
  case pt_classify: //TODO: classify;
d616 1
d619 2
d641 1
a641 1
 run_programlist(b_message,filt,state,pt_filter)
d645 1
a645 1
 run_programlist(b_message,filt,state,pt_exec)
d649 1
a649 1
 run_programlist(b_message,filt,state,pt_subjectmark)
a855 26


/*

 local  :  s+b
 remote :  ss+b_remote

 doublepipe, reaguj na RETR (, eventuelne na TOP)
 reaguj na PASS (-ERR znamena zavreni spojeni a navrat na zacatek)
 zbyle prikazy propust dotaz + odpoved
  RETR:
command RETR number:

         Possible Responses:
             +OK message follows
             -ERR no such message

         Examples:
             C: RETR 1
             S: +OK 120 octets
             S: <the POP3 server sends the entire message here>
             S: .
(skoro)jediny, kde bude neco delat (pocka na celou zpravu, zpracuje, posle celou, nebo zmenenou)

zpravu to prechrousta, zbyle prikazy projdou nezmeneny*/

d882 1
a882 1
 printf("Awaiting connections: %d %d -> %d\n",smtps,pop3s,max(pop3s,smtps)+1);
d884 1
a884 1
  printf("Wake: connection\n");
d889 1
a889 1
   printf("pop3\n");
d896 1
a896 1
   printf("smtp\n");
d903 1
a903 1
  printf("done\n");
@


1.2
log
@*** empty log message ***
@
text
@d277 1
d280 1
d484 52
d684 1
a684 1
//TODO: hlavicka muze byt pres vic radek!
d697 3
a699 3
//TODO:        b2=run_prefilter(&b_message,cfg->p_prefilt);
//TODO:        state=run_classificator(&b2,cfg->p_class);
//TODO:        buf_free(&b2);
d701 3
a703 3
//TODO:       run_postfilter(cfg->p_postfilt,state);
//TODO:       run_postaction(cfg->p_postact,state);
//TODO:       run_subjmark(cfg->subject_mark,state);
@


1.1
log
@Initial revision
@
text
@d6 2
d9 1
d12 1
d14 3
d21 4
d43 2
a44 2
/*
void sendheader(int s,int code,char *str,char *ctype) {
d46 2
a47 1
 sprintf(buf,"HTTP/1.0 %d %s\r\nContent-Type: %s\r\n\r\n",code,str,ctype);
d51 9
a59 46
void senderror(int s,int code,char *str) {
 sendheader(s,code,str,"text/plain");
 send(s,str,strlen(str),0);
}

void handle_www(int is) {
 if (fork()) return;
 handle(is);
 close(is);
 exit(EXIT_SUCCESS);
}

void handle(int is) {
 int bytes,b,i;
 int pos=0;
 int f;
 char buf[2048];//buffer
 char str[sizeof(buf)],*st;
 st=str;
 bytes=0; 
  do {
   if (bytes==sizeof(buf)-1) {
    senderror(is,400,"Malformed request (too long)");
    return;
   }
   b=recv(is,buf+bytes,sizeof(buf)-1-bytes,0);
   chkerror(b);
   bytes+=b;
   buf[bytes]=0;
  } while (!strstr(buf,"\r\n\r\n"));
  if (!sscanf(buf,"GET %s HTTP",str)) {
   senderror(is,400,"Malformed request (no GET)");
   return;
  }
  while (st[0]=='/') st++;
  printf("File %s requested\n",st);
  f=open(st,"r");
  if (!f) {
   senderror(is,404,"File not found");
   return;
  }
  sendheader(is,200,"OK","text/plain");
  chkerror(sendfile(is,f,&pos,0x7fffffff));
  close(f);
 }
*/
d64 1
d74 2
a78 3
config *active; //aktivni konfigurace
char *configfile;//jmeno aktualniho konfiguracniho souboru

d88 1
a88 1
 if (!configfile) configfile=strdup(DEFAULT_CONFIG_FILE);
a89 1
 //TODO
d92 71
a162 1
typedef void (threadfunc)(int param);//funkce threadu
d171 8
a178 1
 t->func(t->sock);
d181 1
d187 2
a188 1
 dup_t=malloc(sizeof(thread_rec));
d190 13
a202 2
 //TODO: startovat nasledujici v threadu
 net_thread(dup_t);
d205 201
d412 57
a468 3
//	    RCPT <SP> TO:<forward-path> <CRLF>
void smtp_handler(int s) {
 //TODO
d471 212
d684 1
a684 2
/**
POP3 proxy - start double pipe
d686 2
a687 1
*/
d689 3
a691 9
/*odpovez:
 +OK argv[0] pop3 ready
label0:
 cekej na USER (jinak -ERR)
 user: nakonekti se na skutecny pop3, posli mu user a zacni double pipe
 -> OK -> posli pass
 ->err na user/pass -> disconnectni se, return to label0:
 
 sem tam: doublepipe, reaguj na RETR (, eventuelne na TOP)
d708 3
a710 2
void pop3_handler(int s) {
 //TODO
a716 1
 int i;
a718 2
 int port;
 char *dir;
d722 4
d734 3
a736 1
 while (select(2,&fds,NULL,NULL,NULL)) {
d741 1
d748 1
d751 5
d757 2
@
