#!/usr/bin/perl

# filtr pro classify-filter: prevede base64 na text
# nekteri spammeri si mysli ze kdyz zpravyu zakoduji do
# base64 ze pak projde filtry, ale to se seredne pletou
# pouziti: base64_decode.pl <[mail] >[out_mail]

sub decode_base64 ($)
{
 local($^W) = 0;
 my $str=shift;
 my $res="";
 $str=~tr|A-Za-z0-9+=/||cd;       # odstran newliny, mezery a tak
 while(length($str)%4) {
  $str.="=";   #nejak doplnit ...
 }
 $str=~s/=+$//;                   # odstran padding
 $str=~tr|A-Za-z0-9+/| -_|;       # -> uuencode format
 while($str=~/(.{1,60})/gs) {
  my $len=chr(32+length($1)*3/4); # bajt s delkou
  $res.=unpack("u",$len.$1);    # uudecode
 }
 return $res;
}


$state=0;
binmode STDOUT;
while (<STDIN>) {
 if (/^$/ && $state==2) {
  $l=decode_base64($l);
  print STDOUT "\n".$l."\n";
  $l="";
  $state=0;
 }
 if (/^Content-Transfer-Encoding:\s*base64/i) {
  $state=1;
  s/base64/8-bit/;
 }
 if (/^$/ && $state==1) {
  $state=2;$l="";
 }
 if ($state==2) { #prave parsuju base64
  $l.=$_;
 } else {
  print STDOUT $_;
 }
}
if ($state==2) {
 $l=decode_base64($l);
 print STDOUT "\n".$l."\n";
}
